package it.dsestili.jhash.test;

/*
JHash a simple hash code generator
Copyright (C) 2013 Davide Sestili

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

import java.io.File;
import java.text.DecimalFormat;
import java.util.Timer;
import java.util.TimerTask;
import it.dsestili.jhash.core.Core;
import it.dsestili.jhash.core.IProgressListener;
import it.dsestili.jhash.core.ProgressEvent;

public class Test implements IProgressListener 
{

	private void test()
	{
		/*
		String[] algorithms = Core.getAlgorithms();
		
		for(String algorithm : algorithms)
		{
			System.out.println(algorithm);
		}
		*/
		
		try
		{
			String fileName = "C:\\Users\\Davide\\Desktop\\[CBD] Dati + Foto.iso";
			System.out.println("File name: " + fileName);
			File file = new File(fileName);
			final Core core = new Core(file, "SHA-1");
			core.addIProgressListener(this);

			/*
			Timer timer = new Timer(true);
			timer.schedule(new TimerTask() {
				@Override
				public void run() 
				{
					core.interrupt();
				}
			}, 10000);
			*/

			long start = System.currentTimeMillis();
			String hash = core.generateHash();
			long elapsed = System.currentTimeMillis() - start;
			
			System.out.println("Hash: " + hash.toUpperCase());
			
			DecimalFormat myFormatter = new DecimalFormat("###.##");
			double seconds = (double)elapsed / 1000.0;
			System.out.println("Elapsed time: " + myFormatter.format(seconds) + " seconds");
		}
		catch(InterruptedException e)
		{
			System.out.println("Operation canceled!");
		}
		catch(Throwable t)
		{
			t.printStackTrace();
		}
	}
	
	public static void main(String[] args) 
	{
		new Test().test();
	}

	@Override
	public void progressEvent(ProgressEvent event) 
	{
		System.out.println(event);
	}
	
}
